=== debian/changelog ===
xrt (1:2.21.75-1) unstable; urgency=medium

  * New upstream version.
    - Fixes FTBFS with newer boost (Closes: #1110612)
  * Drop multi-arch declaration for all packages
  * d/control: Drop libboost-system-dev (Closes: #1127301)
  * Add a patch from Andreas Beckmann for 6.18 support for xocl
    (Closes: #1121155)

 -- Mario Limonciello <superm1@debian.org>  Tue, 10 Feb 2026 21:28:42 -0600
